var _gaPlugin;
var onDeviceReady = function(){
    navigator.splashscreen.hide();
    window.ga.startTrackerWithId('UA-44093014-2')
}

document.addEventListener("deviceready", onDeviceReady, false);

// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
var app = angular.module('starter', [
    'ionic',
    'starter.controllers',
    'starter.services',
    'starter.directives',
    'ionic.contrib.ui.tinderCards',
    'ionic.giphy',
    'ngCordova',
    'ionic-native-transitions'
])
.run(function($ionicPlatform,$cordovaGoogleAnalytics, $ionicHistory, popupService) {
    $ionicPlatform.ready(function() {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        //ionic.Platform.fullScreen();
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
            $ionicConfigProvider.scrolling.jsScrolling(false);
        }

        ionic.Platform.fullScreen();
        if (window.StatusBar) {
          return StatusBar.hide();
        }

        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleDefault();
        }
        //$cordovaGoogleAnalytics.startTrackerWithId('UA-81284363-1');
    });

    $ionicPlatform.registerBackButtonAction(function(e) {
      e.preventDefault();
        var previousState = $ionicHistory.backView().stateName;
        var currentState = $ionicHistory.currentView().stateName;
        if (currentState.indexOf('home') !== -1 && previousState.indexOf('public') !== -1) {
          popupService.confirm('Do you want to exit the application?', function(ok){
            if(ok)
              navigator.app.exitApp();
          })
        }
        else {
          $ionicHistory.goBack();
        }
      }, 1000);
})
.config(function($ionicConfigProvider, $compileProvider, $ionicNativeTransitionsProvider) {
    
    $ionicConfigProvider.backButton.text('').icon('ion-ios-arrow-back');
    
    $ionicConfigProvider.navBar.alignTitle('center');
    $ionicConfigProvider.views.swipeBackEnabled(false);
    $ionicConfigProvider.views.forwardCache(true);

    $ionicNativeTransitionsProvider.setDefaultTransition({
        type: 'slide',
        direction: 'left'
    });
    
    $ionicNativeTransitionsProvider.setDefaultBackTransition({
        type: 'slide',
        direction: 'right'
    });

    $ionicNativeTransitionsProvider.enable(true);
    
    //uncomment for production build
    $compileProvider.debugInfoEnabled(false);
});

toastr.options = {
  "closeButton": false,
  "debug": false,
  "newestOnTop": false,
  "progressBar": false,
  "positionClass": "toast-bottom-full-width",
  "preventDuplicates": false,
  "onclick": null,
  "showDuration": "300",
  "hideDuration": "1000",
  "timeOut": "5000",
  "extendedTimeOut": "1000",
  "showEasing": "swing",
  "hideEasing": "linear",
  "showMethod": "fadeIn",
  "hideMethod": "fadeOut"
}