//TODO: temporary for a build
function readTextFile(file) {
    var rawFile = new XMLHttpRequest();
    rawFile.open("GET", file, false);
    rawFile.onreadystatechange = function() {
        if (rawFile.readyState === 4) {
            if (rawFile.status === 200 || rawFile.status == 0) {
                var allText = rawFile.responseText;
                localStorage['LookupData'] = allText;
            }
        }
    }
    rawFile.send(null);
}

//fetch from file
if (!localStorage['LookupData'])
    readTextFile("lookupdata.txt");

app.controller('baseCtrl',
    function($scope, ajaxService, $ionicLoading,$ionicHistory
        , $timeout, $state, urlService, $filter
        , $ionicNativeTransitions, facebookApiService
        ,$rootScope,$ionicHistory, listService, $ionicPopup
        , pushNotificationService, $ionicModal
        , $cordovaGoogleAnalytics, tutorialService
        , $interval, popupService) {

        /*indicater weather to change card or not when user get 
        * back from profile view
        */
        $scope.changeCard = false;
        
        $scope.CompanyId = 1;
        $scope.AppVersion = '3.0.0.5';
        $scope.PushNotificationEnabled = localStorage.IsPushNotificationEnabled == "true";
        $scope.updatePushNotificationStatus = function(enabled){
            $scope.PushNotificationEnabled = enabled;
        }
        
        // $ionicModal.fromTemplateUrl('templates/modals/lockFeatureModal.html', {
        //     scope: $scope,
        //     animation: 'slide-in-up'
        // }).then(function (modal) {
        //     $scope.lockFeatureModal = modal;
        // });

        $scope.checkPushNotification = function(){
            if(!$scope.PushNotificationEnabled){
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Push Notification',
                    template: '<figure class="pushNotiPopImg"></figure><br/><span class="textCenBlk">Allow push notification to instantly get notified of new messages, image approvals, admin messages, and much more..</span>'
                });

                confirmPopup.then(function(res) {
                    if(res) {
                        pushNotificationService.initialize($scope);
                    }
                });
            }
        }

        var _getDescritpion = $filter('GetDescription');
        $scope.imageUploadedForApproval = false;
        $scope.goToPayment = function(){
            $scope.closeTutorial();
            if(device !== undefined){
                if (device.platform.toLowerCase() == 'ios'){
                    $scope.paymentPageRef = 'home.iosPaymentPlan';
                }
                else{
                    $scope.paymentPageRef = 'home.paymentPlan';
                }
                $ionicNativeTransitions.stateGo($scope.paymentPageRef, {}, {}, {
                    "type": "slide",
                    "direction": "up"
                });
            }
        }

        // Check device 
        $scope.IsDeviceIOS = function(){
            if(device !== undefined)
                return (device.platform.toLowerCase() == 'ios')
            return false;
        }
        /*edit/view profile details start*/
        var _getStateProvince = function(CountryId){
            $scope.ajaxGetPromise('ProfileApi/StateProvinces', {countryId : CountryId})
                .then(function(response){
                    $scope.LookupData.StateProvinces = response.Payload;
                })
        }

        var _setProfileEditList = function(){
            $scope.AdvanceFiltersList = listService.advanceFilterList($scope.LookupData, $scope.CurrentUser.ShortDetails.Gender);
            $scope.ProflieDetailList = listService.detailFilterList($scope.CurrentUser.ShortDetails.Gender);
            $scope.Details = $scope.CurrentUser.Details.ProfileDetailsViewModel;
            var _profileOverView = $scope.CurrentUser.Details.ProfileOverviewModel;
            $scope.Details.Age              = _profileOverView.Age;
            $scope.Details.Height           = _profileOverView.Height;
            $scope.Details.Denomination     = _profileOverView.Denomination;
            $scope.Details.MaritalStatus    = _profileOverView.MaritalStatus;
            $scope.Details.Country          = _profileOverView.Country;
            $scope.Details.ProfileType      = _getDescritpion($scope.LookupData.ProfileTypes, $scope.Details.ProfileTypeId)
            $scope.Details.Username         = _profileOverView.Username;
            $scope.Details.DateOfBirthD     = angular.copy($scope.Details.DateOfBirth)
            $scope.Details.DateOfBirth      = moment($scope.Details.DateOfBirth, 'MM/DD/YYYY').toDate();
            $scope.$watch('Details.DateOfBirth', function(newVal){
                if(newVal){
                    $scope.Details.DateOfBirthD = moment(newVal).format('DD/MM/YYYY');
                }
            })            
        }
        /*edit/view profile details end*/
        $scope.AdvanceFilters = [];
        var arrayFilter = $filter('arrayFilter');
        $scope.Token = '';
        $scope.resetToken  = function(){
            $scope.Token = null;
        }
        $scope.activeService = 0;
        $scope.CurrentUser = {
            ShortDetails: {},
            Details: {},
            Images: {}
        };

        $scope.updateActiveService = function(num){
            $scope.activeService += num;
        }
        
        $scope.InitializeBase = function() {
            autoLogin();
        }

        /*Auto login section start*/
        var autoLoginRemainingAttemps = 3;
        var autoLogin = function() {
                if (localStorage['facebook_login']) {
                    $scope.FacebookSignIn();
                } else if (localStorage['Email'] && localStorage['Password']) {
                    var verificationObj = $scope.getVerificationToken(localStorage['Email'], localStorage['Password'])
                    var headers = {
                        VerificationToken: verificationObj.Hash
                    };

                    var request = {
                        Email: localStorage['Email'],
                        Password: localStorage['Password'],
                        Version: $scope.AppVersion,
                        Ticks: verificationObj.Ticks
                    }

                    var promise = $scope.ajaxPostPromise('SessionApi/Login', request, false, headers);
                    promise.then(function(response) {
                        if (!response.Success) {
                            $state.go('home.login');
                            return;
                        }
                        $scope.LoadProfileData(response.Payload.Token);
                    }, function(err) {
                        autoLoginRemainingAttemps--;
                        if(autoLoginRemainingAttemps > 0)
                            autoLogin();
                        else{
                            $state.go('home.login');
                        }
                    })
                }
            }
            /*auto login section end*/
            /* FaceBook Login Start */
        $scope.adminDisabledProfileModal = {};
        /*current user start*/
        $scope.LoadProfileData = function(token, newRegistration) {
                $scope.Token = token;
                $scope.ajaxGetPromise('ProfileApi/GetData', null).then(function(response) {
                    $scope.CurrentUser.AccountInfo = response.Payload.AccountInfo;

                    _setPreviousSerach(response.Payload.PreviousSearch);
                    $scope.CurrentUser.ShortDetails = response.Payload.ProfileInfo;
                    $scope.CurrentUser.Images = response.Payload.Images;
                    $scope.CurrentUser.Details = response.Payload.ProfileDetails;
                    $scope.CurrentUser.Interests = response.Payload.Interests;
                    $scope.CurrentUser.ProfileOverviewModel = response.Payload.ProfileDetails.ProfileOverviewModel;
                    $scope.CurrentUser.ProfileCompletion = response.Payload.ProfileCompletion;
                    $scope.CurrentUser.FacebookAccount = response.Payload.FacebookAccountDetails;
                    $scope.CurrentUser.IsPaid = response.Payload.ProfileInfo.IsPaid;
                    $scope.CurrentUser.Subscription = response.Payload.SubscriptionDetails;
                    _setProfileEditList();
                    
                    if($scope.CurrentUser.AccountInfo.IsUserDisabled){
                        $ionicNativeTransitions.stateGo('home.deletedProfile', {}, {}, {
                            "type": "slide"
                        });
                        return;
                    }
                
                    /*admin disabled user*/
                    if($scope.CurrentUser.ShortDetails.ProfileStatus <= 3){
                        $scope.ajaxGetPromise('ProfileApi/GetStatusReason')
                            .then(function(response){
                                if(!response.Success) return;
                                $scope.CurrentUser.StatusReason = response.Payload.Reason;
                            })
                    }

                    if($scope.CurrentUser.ShortDetails.ProfileStatus == 1){
                        $ionicModal.fromTemplateUrl('templates/modals/adminDisabledProfileModal.html', {
                          scope: $scope,
                          animation: 'slide-in-up'
                        }).then(function(modal) {
                          modal.show();
                          $scope.adminDisabledProfileModal = modal;
                        });            
                        return;
                    }

                    /*admin restricted or review profile status*/
                    if($scope.isRestrictedUser()){
                        $ionicNativeTransitions.stateGo('home.settingMain', {}, {}, {
                            "type": "slide"
                        });
                        return;
                    }

                    _getStateProvince($scope.CurrentUser.Details.ProfileDetailsViewModel.CountryId)

                    $ionicNativeTransitions.stateGo('home.explore', {}, {}, {
                        "type": "slide"
                    });
                    
                    if(newRegistration)
                        tutorialService.process($scope, 'onRegistration', true);

                    _setNotificationPopupInterval();

                }, function(err) {

                })
            }
            /*current user start*/
            /*profile image helpers start*/
       
       $scope.isRestrictedUser = function(){
           return ($scope.CurrentUser.ShortDetails.ProfileStatus <= 3)
       }

        $scope.GetImageNo = function(no) {
            if ($scope.CurrentUser.Images.length >= no) {
                image = $scope.CurrentUser.Images[no - 1];
                return { Url : $scope.GenerateImageUrl(image.ImageUrl), id : image.Id }
            }

            return {Url :$scope.GenerateImageUrl(''), id : 0};
        }

        $scope.GenerateImageUrl = function(string, type) {
                if (string && string.length > 0) {
                    var sub = string.substring(0, 4)
                    var image = (sub == 'http') ? string : urlService.compose(string)
                    return image + '_164x164.jpg'
                }
                //return default image
                var gender = $scope.CurrentUser.ShortDetails.Gender;
                if (type === false) {
                    gender = (gender == 'M') ? 'F' : 'M'
                }

                if (!gender) {
                    var path = 'img/trans_ground.png'
                    return urlService.compose(path)
                }

                var path = 'img/user-gravatar_' + gender.toLowerCase() + '.png'
                if (path == 'img/user-gravatar_undefined.png')
                    return ''
                return path;
            }
            /*profile image helpers end*/

        /* loader start*/
        $scope.addLoadEvent = function() {
            $scope.activeService++;
        }

        $scope.$watch('activeService', function(newVal, oldVal) {
            if (typeof newVal == 'undefined') return;
            if (newVal == 0)
                $ionicLoading.hide();
            else
                $ionicLoading.show({
                    template    : '<ion-spinner></ion-spinner>',
                    noBackdrop  : false
                });
        })

        $scope.removeLoadEvent = function() {
                $scope.activeService--;
            }
            /* loader start end*/

        /* ajax overloads start*/
        $scope.ajaxGet = function(url, data, successCallback, errorCallback) {
            ajaxService.Get(url, data, successCallback, errorCallback, $scope);
        }

        $scope.ajaxGetPromise = function(url, data, isBackground) {
            return ajaxService.GetPromise(url, data, $scope, isBackground);
        }

        $scope.ajaxPost = function(url, data, successCallback, errorCallback) {
            ajaxService.Post(url, data, successCallback, errorCallback, $scope);
        }

        $scope.ajaxPostPromise = function(url, data, isBackground, headers) {
            return ajaxService.PostPromise(url, data, $scope, isBackground, headers);
        }

        $scope.ajaxPostSecure = function(url, data, successCallback, errorCallback) {
            ajaxService.Post(url, data, successCallback, errorCallback, $scope, true);
        }

        $scope.GetBackground = function(url, data, successCallback, errorCallback) {
                ajaxService.GetBackground(url, data, successCallback, errorCallback, $scope);
            }
            /* ajax overloads end*/

        /*helpers start*/
        $scope.GetAge = function(DateOfBirth) {
            var birthday = new Date(DateOfBirth);
            return ~~((Date.now() - birthday) / (31557600000));
        }

        $scope.getArray = function(length) {
            return new Array(length);
        }

        $scope.SaveObject = function(key, object) {
            localStorage.setItem(key, JSON.stringify(object));
        }

        $scope.RemoveObject = function(key) {
            localStorage.removeItem(key);
        }

        $scope.GetObject = function(key) {
                var retrievedObject = localStorage.getItem(key);
                return JSON.parse(retrievedObject);
            }
            /*helpers start*/

        /* lookup data start*/
        if (localStorage.LookupData) {
            //update in background
            $scope.LookupData = $scope.GetObject('LookupData');
            $scope.AdvanceFilters = $scope.GetObject('LookupData');
            $scope.ajaxGetPromise('profileapi/getlookupdata', null, true)
                .then(function(res) {
                    $scope.SaveObject('LookupData', res.Payload);
                })
        }
        /* lookup data start*/

        /* Search page bindings start*/
        $scope.PreviousSearch = {};
        var _setPreviousSerach = function(data) {
            $scope.PreviousSearch = data;
            $scope.PreviousSearch.SelectedDenominations = arrayFilter($scope.LookupData.Denominations, data.denominationList, 'Value');
            $scope.PreviousSearch.SelectedCountries = arrayFilter($scope.LookupData.Countries, data.locationCountryList, 'Value');
            $scope.PreviousSearch.SelectedMaritalStatuses = arrayFilter($scope.LookupData.MaritalStatuses, data.maritalStatusList, 'Value');
            $scope.PreviousSearch.OnlineSinceOptions = $scope.LookupData.OnlineSinceOptions // arrayFilter($scope.LookupData.OnlineSinceOptions, [data.onlineSince], 'Value');
        };

        $scope.getVerificationToken = function(email, password) {
                var ticks = moment.utc().unix();
                var obj = {
                    Ticks: ticks,
                    Email: email
                }
                if(password !== undefined)
                    obj.Password = password;
                var hashSource = JSON.stringify(obj)
                var key = "(-/M@tchM0bileDef@ultP@55w0rd!-)"
                var hash = CryptoJS.HmacMD5(hashSource, key)
                return {
                    Hash: hash,
                    Ticks: ticks
                };
            }
            /* Search page bindings end*/
        $scope.EmptyClickHandler = function() {}

        // facebook handlers start
        $scope.FacebookId;
        $scope.FacebookEmail;
        $scope.FacebookSignIn = function() {
                facebookApiService.IsUserLoggedIn(function(isLoggedIn) {
                    if (isLoggedIn) {
                        facebookApiService.fetchPublicProfile(function(success, data) {
                            if (success) {
                                $scope.FacebookId = data.id;
                                $scope.FacebookEmail = data.email;
                                var data = {
                                    FacebookId: $scope.FacebookId,
                                    FacebookEmail: $scope.FacebookEmail
                                };
                                var promise = $scope.ajaxPostPromise('SessionApi/FbLogin', data);
                                promise.then(function(response) {
                                    if (response.Payload.AccountExist) {
                                        localStorage['facebook_login'] = true;
                                        $scope.LoadProfileData(response.Payload.Token);
                                    } else {
                                        $state.go('public.accountNotExist', data);
                                    }
                                })
                            } else {
                                alert('Facebook: Login Failed');
                            }
                        })
                    } else {
                        var permissionString = 'email';
                        facebookApiService.login(permissionString, function(response) {
                            if (response.authResponse) {
                                $scope.FacebookSignIn();
                            } else {
                                alert('User cancelled login or did not fully authorize.');
                            }
                        }, function(e) {
                            alert('Facebook: Login Failed or didn\'t fully authorize. Message: ' + e.errorMessage);
                        });
                    }
                })
            }
            /* FaceBook Login End */
            //facebook handler end

            $scope.$on('$locationChangeStart', function(event) {
                toastr.clear(); // clear all toastr messages before leaving page
            });

            $rootScope.$on('$stateChangeSuccess', function(event, to, toParams, from, fromParams) {
                //save the previous state in a rootScope variable so that it's accessible from everywhere
                $scope.previousState = from;
                try{
                    if(window.ga){
                        window.ga.trackView(to.url)
                    }
                }catch(err){
                    //alert(err.message)
                }
            });

            // Go Back slide down
            $scope.goBackDown  = function(){
                $ionicHistory.goBack();
                if(window.plugins && window.plugins.nativepagetransitions){
                    window.plugins.nativepagetransitions.slide({
                        "direction": 'down'
                    });            
                }
            }

            $scope.shareApp = function(){
                var url;
                try{
                    if (device.platform.toLowerCase() == 'ios'){
                        url = "https://itunes.apple.com/us/app/nikah-explorer/id890550233?mt=8";
                    }else{
                        url = "https://play.google.com/store/apps/details?id=com.NikahExplorer.application";
                    }
                    window.plugins.socialsharing.share('NikahExplorer', null, null, url)
                }catch(err){
                    alert(err.message)
                }                
            }

            $scope.isCurrentState = function(state){
                return  ($ionicHistory.currentView().stateName === state);
            }

            $scope.closeTutorial = function(state){
                tutorialService.close(state);
            }

            $rootScope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams){
                var event;
                switch(toState.name){
                    case 'home.explore'://swipe view
                        event = 'onExplorerView';
                        break;
                    case 'home.matchMain'://conversation
                        event = 'initiateChat';
                        break;
                    case 'home.settingMain'://dashboard
                        event = 'dashboard';
                        break;
                    case 'home.profile_edit':
                        event = 'completeProfileDetails';
                        break;
                    case 'home.completeTask':
                        event = 'promoteYourself';
                        break;
                    case 'home.questionAnswer':
                        event = 'answerMatchQuestion';
                        break;
                    default:
                        return;
                }

                if(event !== 'onExplorerView'){
                    /*only set date and return if date not set*/
                    if(!localStorage.firstLoginTime){
                        localStorage.firstLoginTime = new Date().toString();
                        return;
                    }

                    var date = new Date(localStorage.firstLoginTime);

                    //if first login is within 2 days return
                    //don't show notificatinon popup interval
                    if(_daysBetween(date, new Date()) <= 2)
                        return;
                }

                $timeout(function(){
                    tutorialService.process($scope, event);
                }, 2000)
            });

            function _daysBetween( date1, date2 ) {
              //Get 1 day in milliseconds
              var one_day=1000*60*60*24;

              // Convert both dates to milliseconds
              var date1_ms = date1.getTime();
              var date2_ms = date2.getTime();

              // Calculate the difference in milliseconds
              var difference_ms = date2_ms - date1_ms;
                
              // Convert back to days and return
              return Math.round(difference_ms/one_day); 
            }

            var _setNotificationPopupInterval = function(){
                var popups = [];
                if(!$scope.CurrentUser.ShortDetails.IsPaid)
                    popups.push('getKey');
                var interval = $interval(function(){
                    if(popups.length == 0)
                        return;
                    var p = popups.pop();
                    var shown = tutorialService.process($scope, p, true);
                    if(!shown)
                        popups.push(p);
                    if(popups.length == 0)
                        $interval.cancel(interval);
                }, 30000)
            }

            $scope.sendVerificationEmail = function(){
                $scope.ajaxPostPromise('AccountApi/ResendVerficationEmail')
                    .then(function(response){
                        if(!response.Success)
                            return;
                        $scope.closeTutorial();
                        var msg = "Verification email sent at "+$scope.CurrentUser.AccountInfo.Email+" Please follow the instructions in that email"
                        popupService.show(msg)
                    })
            }
    });
