app.controller('basicFilterSliderCtrl', function($scope,$ionicSlideBoxDelegate, popupService, $stateParams, $timeout,$ionicScrollDelegate, $ionicNativeTransitions) {
    popupService.showSwipeMsg($scope);
    $scope.showLoading = true;
    $scope.enableSlide = function(enable){ 
        $ionicSlideBoxDelegate.enableSlide(enable); 
    };

    $scope.slideChanged = function(index){
        $timeout(function(){
            $ionicScrollDelegate.$getByHandle('basicFilterSlider').scrollTop();
        },10)
    }
    var _slides = [{
        Header: 'Age',
        ModelPropertyName: 'ageFrom',
        SubModelPropertyName: 'ageTo',
        hasAge: true
    }, {
        Header: 'Location',
        LookupPropertyName: 'SelectedCountries',
    }, {
        Header: 'Marital Status',
        LookupPropertyName: 'SelectedMaritalStatuses',
    }, {
        Header: 'Denomination',
        LookupPropertyName: 'SelectedDenominations',
    }, {
        Header: 'Last Online',
        LookupPropertyName: 'OnlineSinceOptions',
        ModelPropertyName : 'onlineSince',
        Last: true,
        IsRadioType : true
    }];

    $timeout(function(){
    	$scope.Slides = _slides;
        $timeout(function(){
            $scope.activeSlide = $stateParams.Index;
            $ionicSlideBoxDelegate.update();
    	    $scope.showLoading = false;
    	},100)
    }, 300)

	$scope.NextSlide = function(){
        $ionicSlideBoxDelegate.next();
    }

    $scope.applyFilters = function(){
        $ionicNativeTransitions.stateGo('home.explore', {}, {}, {
            "type": "slide",
            "direction": "down"
        });
    }
})