app.controller('detailFilterCtrl', function($scope, $filter, listService, $ionicNativeTransitions, $timeout) {
    var _filter = $filter('filter')

    $scope.goToSlider = function(index){
        localStorage.detailFilterIndex = index;
        $ionicNativeTransitions.stateGo('home.detailFilterSlider', {}, {}, {
            "type": "slide",
            "direction": "up"
        });
    }

    $scope.$on('$ionicView.enter', function() {
        $timeout(function(){
            _setSelectedFilters();
        },100)
    });

    var _setSelectedFilters = function(){
        if(!localStorage.DetailFilters) return;
        var addFilters  = JSON.parse(localStorage.DetailFilters);
        for (var property in addFilters) {
            if (addFilters.hasOwnProperty(property)) {
                var item = _filter($scope.ProflieDetailList, {QueryPropName : property})[0]
                if(item === undefined) continue;
                item.Selected = true;
                var filters = item.Lookup;
                angular.forEach(addFilters[property], function(id){
                    _filter(filters, id)[0].IsChecked = true;
                })
            }
        }
    }
});