app.controller('signinCtrl', function($scope, $state, $timeout, $ionicModal, $http) {
	$scope.SigninRequest = {
		Version : $scope.AppVersion,
		RememberMe : true,
		//TODO: remove this
		// Password : 'Password1',
		// Email: 'mohammadzee@gmail.com',
	};

	$http.get('http://ip-api.com/json')
		.then(function(response){
			$scope.SigninRequest.Latitude = response.data.lat;
			$scope.SigninRequest.Longitude = response.data.lon;		
		});

	var _outDatedModal;
	$timeout(function(){ _loadModal(); }, 500);
	var _loadModal = function(){
            $ionicModal.fromTemplateUrl('templates/modals/outDatedModal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              _outDatedModal = modal;
            });            
        }

	// $scope.showOutDatedModal = function() {
    //       _outDatedModal.show();
    //     };

	$scope.closeOutDatedModal = function() {
		_outDatedModal.hide();
	};

	$scope.signin = function(request){
		var verificationObj = $scope.getVerificationToken(request.Email, request.Password)
		var headers = {VerificationToken : verificationObj.Hash};
		request.Ticks = verificationObj.Ticks;
		var promise = $scope.ajaxPostPromise('SessionApi/Login', request, false, headers);
		promise.then(function(response){
			if (response.Success)
			{
				if(request.RememberMe){
					localStorage['Email'] = request.Email;
					localStorage['Password'] = request.Password;
				}
				$scope.$parent.LoadProfileData(response.Payload.Token);
			}else{
				var msg  = response.Messages[0].indexOf('out-dated');
				if(msg > 0){
					_outDatedModal.show();
				}
			}
		},function(response){
		});
	}

			

});
