app.directive('matchField', function ($parse) {
    return {
        scope: true,
        require: '?ngModel',
        link: function (scope, element, attrs, ngModel) {
            
            attrs.$observe('ngModel', function (value) {
                scope.$watch(value, function (newValue) {
                    var rawElement = angular.element(element)[0];
                    var confirmFieldModel = $parse(attrs.ngModel)(scope);
                    var FieldModel = $parse(attrs.confirmField)(scope);
                    if (FieldModel != confirmFieldModel) {
                        rawElement.setCustomValidity(attrs.withMessage);
                    } else {
                        rawElement.setCustomValidity('');
                    }
                });
            });
        }
    };
});

app.directive('dynamicSlide', function ($parse) {
    return{
        restrict: 'E',
        scope:{
            slidesSource:'@'
        },
       link: function(scope, element, attrs) {
           scope.getContentUrl = function() {
                return attrs.templateUrl;
           }
       },
       template: '<div ng-include="getContentUrl()"></div>'
    }
});