app.controller('paymentPlanCtrl', function($scope, urlService, $state, $ionicHistory) {
    var _getPaymentPlans = function() {
        $scope.ajaxGetPromise('PaymentPlansApi/Index', null, true)
            .then(function(response) {
                $scope.Products = response.Payload.Products;
                console.log($scope.Products)
            })

        $scope.ajaxGetPromise('PaymentPlansApi/GetPaymentPlanLinks', null)
            .then(function(response) {
                $scope.paymentPlanLinks = response.Payload.PaymentPlans;
            })

    }
    _getPaymentPlans();

    var autoLink;
    $scope.buy = function(value) {
        angular.forEach($scope.paymentPlanLinks, function(data) {
            if (value.GatewayId == data.PaymentPlan.GatewayId) {
                autoLink = urlService.compose(data.AutoLink.slice(1));
                _openPaymentProcess(autoLink);
            }
        });
    }

    var _openPaymentProcess = function(link) {
        var options = 'location=no,toolbar=no,clearcache=yes,clearsessioncache=yes'
        var inAppBrowser = cordova.InAppBrowser.open(link, '_blank', options);
        inAppBrowser.addEventListener('loadstop', function(event) {
            var lastSlashIndex = event.url.lastIndexOf('/')
            var action = event.url.substring(lastSlashIndex)
            if (action.toLowerCase() == '/login') {
                _getSubscriptionStatus();
                inAppBrowser.close();
            }
        })
    }

    var _getSubscriptionStatus = function() {
        $scope.ajaxGetPromise('PaymentPlansApi/IosGetSubscription', null)
            .then(function(response) {
                $scope.CurrentUser.ShortDetails.IsPaid = response.Payload.IsActive;
                //redirect to explore page
                $ionicHistory.clearCache()
                    .then(function(){
                        $state.go('home.explore')
                    })
            })
    }
});