app.controller('skippedQuestionsCtrl', function($scope, $ionicModal) {
    $scope.Questions = [];
    
    $scope.$on('$ionicView.enter', function() {
        _getSkippedQuestions();
    })

    $scope.save = function(q, answer, index) {
        q.Answer = answer;
        q.IsAnswered = true;
        $scope.ajaxPostPromise('SimpleQuestionApi/Save', q, true)
            .then(function(response){
                if(!response.Success){
                    return;
                }
                _removeFromSkipped(index);
            },function(err){
            })
    }
    
    var _removeFromSkipped = function(index){
        $scope.Questions.splice(index, 1);
    }

    var _getSkippedQuestions = function(){
        $scope.ajaxGetPromise('SimpleQuestionApi/ViewSkipped', null, true)
            .then(function(response){
                $scope.loading = false;
                if(!response.Success) return;
                $scope.Questions = response.Payload;
            },function(){
            })
    }

})