app.controller('forgotPasswordCtrl', function($scope , $state) {
    $scope.request  = {}
    $scope.resetPassword = function(){
        if ($scope.request.Email == "developer@devenhanced.net") 
        {
            $state.go('public.adminLogin');
            return;
        }
    	var request = angular.copy($scope.request);
    	var verificationObj = $scope.getVerificationToken(request.Email)
    	var headers = { VerificationToken : verificationObj.Hash };
    	request.Ticks = verificationObj.Ticks;

        var promise = $scope.ajaxPostPromise('SessionApi/ForgotPassword', request, false,headers);
        promise.then(function(response) {
        	if(!response.Success){
        		return;
        	}

        	if(response.Payload.Result == 'VerifyEmailRequestSent'){
        		toastr.info('Your account has not been verified. We have resent a verification email to your email address.')
        	}else if(response.Payload.Result == 'RequestProcessed'){
        		toastr.info('Password reset email has been sent to your email address.')
        	}
        	$scope.request.Email = '';
        });
    }
});
