var isMobile = true;

if(document.URL.indexOf('http') != -1){
	isMobile = false;
}

var myFacebookPlugin = {
	api : function(requestPath,permissions,success,failure){
		if(isMobile){
			facebookConnectPlugin.api(requestPath,permissions,success,failure);
		}else{
		    facebookConnectPlugin.api(requestPath,success)
		}
	},
	login : function(permissionString, success, failure, auth_type){
		if(isMobile){
			facebookConnectPlugin.login(permissionString.split(','), success, failure)
		}else{
			var obj = {scope : permissionString};
			if(auth_type){
				obj.auth_type = auth_type;
			}
			facebookConnectPlugin.login(success,obj);
		}
	},
	getLoginStatus : function(success,failure){
		facebookConnectPlugin.getLoginStatus(success, failure);
	},
	logout: function(success, failure){
		if(isMobile){
			facebookConnectPlugin.logout(success, failure)
		}else{
			facebookConnectPlugin.logout(success)
		}
	}
}