app.factory('popupService', function (urlService, $http, $ionicPopup) {
	return {
		showSwipeMsg : function(){
			if(!localStorage['swipeMsgShown']){
			    var alertPopup = $ionicPopup.alert({
			      title   : '<figure class="swipe-LR"></figure><br/><span class="textCenBlk">You can swipe left or right for quick editing</span>',
			      buttons: [{
			      	text: 'Don\'t show again',
			        onTap: function(e) {
			        	localStorage['swipeMsgShown'] = true;
			        }
		            },{
		              text: '<b>Okay</b>',
		              type: 'button-positive'
		            }
		          ]
			    });
			}
		},
		confirm : function(msg,callback){
		    var alertPopup = $ionicPopup.alert({
		      title   : msg,
		      buttons: [{
		      	text: 'Cancel',
		      	onTap : function(){
		      		callback(false)
		      	}
	            },{
	              text: '<b>OK</b>',
	              type: 'button-positive',
	              onTap : function(){
	              	callback(true)
	              }
	            }
	          ]
		    });
		},
		show : function(msg){
		    $ionicPopup.alert({
		      title   : msg,
		      buttons: [{
		      	text: 'Ok',
		      }]
		    });
		}
	}
})
